; test program for printing to screen 
; and requesting from keyboard

dcx sp		; initialize stack (0FFFFh)

lxi h,text		; load text address to HL
call print		; print text

lxi h,entered	; load entered address to HL
xchg		; DE <-> HL
call getline	; get line from keyboard

lxi h,text2
call print
lxi h,entered	; load entered address to HL
call print

hlt

print:
    mov a, m
    inx h
    cpi 0
    rz
    out 11h
    jmp print

;simple routine to get string from keyboard
;in: chars from keyboard till ENTER key
;out: DE reg.pair = start address of loaded text
getline:
    mvi c, 0 ; char count
next_char:
    in 10h
    ani 1 ; test status byte if char is ready
    jz next_char
    in 11h ; read char

    ; interpret some special keys
    cpi 13 ; ENTER
    jz getline_ret
    cpi 8  ; backspace
    jnz save_char

    mov a, c ; test if we are in the beginning
    cpi 0
    jz next_char ; if yes, nothing is done (ignored BS)
    dcx d ; address--;
    dcr c ; charcount--;
    mvi a,8 ; send backspace to the screen
    out 11h
    mvi a, 32 ; clear char by ' '
    out 11h
    mvi a,8 ; backspace again
    out 11h
    jmp next_char
save_char:
    out 11h
    stax d
    inx d
    inr c
    jmp next_char
getline_ret:
    mvi a, 10
    stax d
    inx d
    mvi a,13
    stax d
    inx d
    mvi a, 0
    stax d
    ret
    
text: db 'Hello, world !',10,13,'Enter text: ',0
text2: db 10,13,'You entered: ',0
entered: ds 30